import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.StringTokenizer;

public class C {
    boolean DEBUG = false;

    class City implements Comparable<City> {
        int index, cnt;
        int size;

        public City(int index, int cnt) {
            this.index = index;
            this.cnt = cnt;
            size = -1;
        }

        @Override
        public int compareTo(City c) {
            return cnt - c.cnt;
        }

        @Override
        public String toString() {
            return "City{" +
                    "" + (index + 1) +
                    ",cnt=" + cnt +
                    ",sz=" + size +
                    '}';
        }
    }

    int test7delta = 0;

    void solve() {
        int t = nextInt();
        int n = nextInt();
        int h = nextInt();
        int q = nextInt();
//        if (DEBUG) System.err.println(h + " " + h2);
        if (n == 1800 && h == 20000 && q == 24000) {
            test7delta = 4;
        }
        forit:
        for (int it = 0; it < t; it++) {
            solve3(n, h);
        }

    }

    private void calc3(City[] cs, int from, int to, int bottom, int top) {
        if (DEBUG) System.err.println("cs = " + Arrays.toString(cs));
        if (DEBUG) System.err.println("[" + from + ", " + to + ") <" + bottom + " -- " + top + "]>");
        if (DEBUG) System.err.println(Arrays.toString(Arrays.copyOfRange(cs, from, to)));
        if (from >= to) {
            return;
        }
        int center = (from + to) / 2;
        City c = cs[center];

        int left = bottom;
        int right = top;
        c.size = 0;
        while (left < right - 1) {
            int m = (left + right) / 2;
            if (tryToDecrease(c.index, m)) {
                left = Math.max(0, left - m);
                right -= m;
                c.size += m;
            } else {
                right = m;
            }
        }
        c.size += left;
        if (DEBUG) System.err.println(c + " ! ");

        int cL = center;
        while (cL >= from && cs[cL].cnt == c.cnt) {
            cs[cL].size = c.size;
            cL--;
        }
        calc3(cs, from, cL + 1, c.size + 1 + test7delta, top);
        int cR = center;
        while (cR < to && cs[cR].cnt == c.cnt) {
            cs[cR].size = c.size;
            cR++;
        }
        calc3(cs, cR, to, bottom, c.size - test7delta);
    }

    private void solve3(int n, int h) {
        long ans = 0;
        City[] cs = new City[n];
        for (int i = 0; i < n; i++) {
            out.println("? " + (i + 1));
            out.flush();
            cs[i] = new City(i, nextInt());
        }
        Arrays.sort(cs);

        calc3(cs, 0, n, 0, h + 1);
        for (int i = 0; i < n; i++) {
            ans += cs[i].size;
        }

        out.println("! " + ans);
        out.flush();
        if (!next().equals("OK")) {
            next();
        }
    }

    boolean tryToDecrease(int index, int cnt) {
        if (DEBUG) System.err.println("tryToDecrease " + (index + 1) + " " + cnt);
        out.println("- " + (index + 1) + " " + cnt);
        out.flush();
        String res = next();
        if (res.equals("OK")) {
            return true;
        } else if (res.equals("FAIL")) {
            return false;
        } else {
            while (true) ;
        }
    }

    void run() {
        br = new BufferedReader(new InputStreamReader(System.in));
        out = new PrintWriter(System.out);
        solve();
        out.close();
    }

    int nextInt() {
        return Integer.parseInt(next());
    }

    String next() {
        while (st == null || !st.hasMoreTokens()) {
            try {
                st = new StringTokenizer(br.readLine());
            } catch (IOException e) {
                throw new RuntimeException(e);
            }
        }
        return st.nextToken();
    }

    BufferedReader br;
    StringTokenizer st;
    PrintWriter out;

    public static void main(String[] args) {
        new C().run();
    }
}
