#include "testlib.h"
#include <vector>

using namespace std;

int main(int argc, char *argv[]) {

    registerTestlibCmd(argc, argv);

    int t = inf.readInt();
    int n = inf.readInt(), h = inf.readInt(), q = inf.readInt();

    int gamma = inf.readInt();

    vector<int> c, j;
    for (int test = 0; test < t; test++) {
        if (!ouf.seekEof()) {
            c.push_back(ouf.readInt());
            if (c.back() > q) {
                quitf(_fail, "Contestant's solution exceeded request limit");
            }
        }
        if (!ans.seekEof()) {
            j.push_back(ans.readInt());
            if (j.back() > q) {
                quitf(_fail, "Jury's solution exceeded request limit");
            }
        }
    }

    int min_score = 4;
    if (j.size() < t) {
        quitf(_fail, "Jury didn't solve all the tests");
    }
    if (c.size() < t) {
        quitf(_wa, "Contestant didn't answer all the tests correctly");
    }

    if (t == 1) {
        quitf(_ok, "Sample test, %d requests", c.back());
    }
    string tmp = "";
    for (int test = 0; test < t; test++) {
        int score = max(1, 4 - max(0, (c[test] - j[test]) / gamma));
        min_score = min(min_score, score);
        tmp += to_string(c[test]);
        if (test < t - 1) {
            tmp += ", ";
        }
    }
    
    if (min_score == 4) {
        quitf(_ok, "%s requests", tmp.c_str());
    }
    
    quitp(min_score, "%s requests", tmp.c_str());
}