#include "testlib.h"
#include <vector>
#include <string>

using namespace std;

int main(int argc, char *argv[]) {

    registerInteraction(argc, argv);

    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);

    int t = inf.readInt();
    int n = inf.readInt(), h = inf.readInt(), q = inf.readInt();
    inf.readInt();

    cout << t << '\n';
    cout << n << ' ' << h << ' ' << q << '\n';
    cout.flush();

    for (int test = 0; test < t; test++) {
        vector<int> a(n);
        long long sum = 0;
        for (int i = 0; i < n; i++) {
            a[i] = inf.readInt();
            sum += a[i];
        }

        string req;
        int i, x;
        bool done = false;
        int iter = 0;
        while (!done) {
            req = ouf.readToken("[?!\\-]");
            if (req[0] == '!') {
                long long res = ouf.readLong();
                if (res == sum) {
                    cout << "OK\n";
                    cout.flush();
                } else {
                    cout << "-1\n";
                    cout.flush();
                    quitf(_wa, "invalid answer on test %d: %lld instead of %lld", test, res, sum);
                }
                done = true;
            } else {
                if (iter == q) {
                    cout << "-1\n";
                    cout.flush();
                    quitf(_wa, "number of requests %d exceeded", q);
                }
                iter++;
                if (req[0] == '-') {
                    i = ouf.readInt(1, n) - 1;
                    x = ouf.readInt(0, h);
                    if (x > a[i]) {
                        cout << "FAIL\n";
                    } else {
                        a[i] -= x;
                        cout << "OK\n";
                    }
                } else {
                    i = ouf.readInt(1, n) - 1;
                    int res = 0;
                    for (int ai : a) {
                        if (ai >= a[i]) {
                            res++;
                        }
                    }
                    cout << res << '\n';
                }
                cout.flush();
            }
        }

        tout << iter << '\n';
    }

}