#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>

using namespace std;

int main() {

    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);

    unsigned int t;
    unsigned int n, h, q;
    cin >> t >> n >> h >> q;

    unsigned int step = sqrt(h);

    for (unsigned int test = 0; test < t; test++) {
        vector<pair<unsigned int, unsigned int>> order;
        for (unsigned int i = 0; i < n; i++) {
            cout << "? " << i + 1 << '\n';
            cout.flush();

            unsigned int cnt;
            cin >> cnt;
            if (cnt == -1) {
                return 0;
            }
            order.push_back({cnt, i});
        }

        sort(order.begin(), order.end());
        unsigned int top = order[0].second, cnt = order[0].first;
        vector<unsigned int> bstep(n);

        string s;
        unsigned int d = 0, residual = 0;
        unsigned long long ans = 0;
        unsigned int resp;
        for (; d * step < h;) {
            cout << "- " << top + 1 << ' ' << step << '\n';
            cout.flush();
            cin >> s;
            if (s[0] != 'O') {
                if (s[0] == '-') {
                    return 0;
                }

                unsigned int power = 1;
                while (power * 2 <= step) {
                    power *= 2;
                }
                for (; power > 0; power /= 2) {
                    cout << "- " << top + 1 << ' ' << power << '\n';
                    cout.flush();
                    cin >> s;
                    if (s[0] == 'O') {
                        residual += power;
                    } else if (s[0] == '0') {
                        return 0;
                    }
                }
                ans += residual;
                break;
            }
            d++;
            ans += step;
            if (d * step == h) {
                break;
            }

            cout << "? " << top + 1 << "\n";
            cout.flush();
            cin >> resp;
            if (resp == -1) {
                return 0;
            }
            if (resp > cnt) {
                for (int i = cnt; i < resp; i++) {
                    bstep[order[i].second] = d;
                }
            }
            cnt = resp;
        }
        for (int i = cnt; i < n; i++) {
            bstep[order[i].second] = d + 1;
        }
        bstep[order[0].second] = d + 1;

        for (int i = 0; i < n; i++) {
            if (bstep[i] <= d && (bstep[i] < d || residual > 0)) {
                cout << "- " << i + 1 << ' ' << step * (d - bstep[i]) + residual << '\n';
                cout.flush();
                cin >> s;
                if (s[0] != 'O') {
                    if (s[0] == '-') {
                        return 0;
                    }
                    return 1;
                }
                ans += ((long long) d - bstep[i]) * step + residual;
            }
        }

        order.clear();
        for (unsigned int i = 0; i < n; i++) {
            if (i != top) {
                cout << "? " << i + 1 << '\n';
                cout.flush();

                unsigned int cnt2;
                cin >> cnt2;
                if (cnt2 == -1) {
                    return 0;
                }
                order.push_back({cnt2, i});
            }
        }

        sort(order.begin(), order.end());
        unsigned int top2 = order[0].second, cnt2 = order[0].first;

        vector<pair<unsigned int, unsigned int>> count;
        count.push_back({0, cnt2});

        unsigned long long d2 = 0;
        unsigned int h2 = h / step;
        for (; d2 < h2;) {
            cout << "- " << top2 + 1 << " 1\n";
            cout.flush();
            cin >> s;
            if (s[0] != 'O') {
                if (s[0] == '-') {
                    return 0;
                }
                break;
            }
            d2++;
            if (d2 == h2) {
                break;
            }

            cout << "? " << top2 + 1 << "\n";
            cout.flush();
            cin >> resp;
            if (resp == -1) {
                return 0;
            }
            if (resp > cnt2) {
                count.push_back({d2, resp - cnt2});
            }
            cnt2 = resp;
        }

        for (auto const &p : count) {
            ans += (d2 - p.first) * p.second;
        }

        cout << "! " << ans << '\n';
        cout.flush();

        cin >> s;
        if (s[0] != 'O') {
            return 1;
        }
    }

}