#include <iostream>
#include <vector>
#include <string>

using namespace std;

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    unsigned int n;
    cin >> n;
    vector<string> a(n);
    for (unsigned int i = 0; i < n; i++) {
        cin >> a[i];
    }

    vector<vector<vector<unsigned int>>> cnt(
            n + 1,
            vector<vector<unsigned int>>(
                    6,
                    vector<unsigned int>(11)
            )
    );
    for (unsigned int i = 0; i < n; i++) {
        for (unsigned int j = 0; j < 6; j++) {
            for (unsigned int d = 0; d < 11; d++) {
                cnt[i + 1][j][d] = cnt[i][j][d];
            }
            for (unsigned int d = a[i][j] - '0' + 1; d < 11; d++) {
                cnt[i + 1][j][d]++;
            }
        }
    }

    long long initial = 0;
    for (unsigned int i = 0; i < n; i++) {
        for (unsigned int j = 0; j < 6; j++) {
            unsigned int c = a[i][j] - '0';
            initial += (cnt[n][j][c] - cnt[i + 1][j][c]);
        }
    }

    vector<long long> inv(n + 1);
    auto delta = [&inv, &cnt, &n](unsigned int i) {
        long long t = i;
        long long r = 6L * t * (n - t) - 2 * inv[i];
        for (unsigned int j = 0; j < 6; j++) {
            for (unsigned int d = 0; d < 10; d++) {
                long long total = cnt[n][j][d + 1] - cnt[n][j][d];
                long long left = cnt[i][j][d + 1] - cnt[i][j][d];
                r -= left * (total - left);
            }
        }
        return r;
    };

    unsigned int pos = 0;
    long long dmin = 0;
    for (unsigned int i = 0; i + 1 < n; i++) {
        inv[i + 1] = inv[i];
        for (unsigned int j = 0; j < 6; j++) {
            unsigned int c = a[i][j] - '0';
            inv[i + 1] -= (cnt[i][j][10] - cnt[i][j][c + 1]);
            inv[i + 1] += (cnt[n][j][c] - cnt[i + 1][j][c]);
        }

        long long d = delta(i + 1);
        if (d < dmin) {
            pos = i + 1;
            dmin = d;
        }
    }

    cout << initial + dmin << '\n';

}